#include "ext.h"			
#include "ext_obex.h"	
#import <Foundation/Foundation.h>
#import <Appkit/NSWorkspace.h>

typedef struct _consciousness {	
    t_object c_ob;			
    void *c_outlet1, *c_outlet2;			
} t_consciousness;

void consciousness_assist(t_consciousness *x, void *b, long m, long index, char *s);
void consciousness_inletinfo(t_consciousness *x, void *b, long index, char *t);
void *consciousness_new(void);
void consciousness_free(t_consciousness *x);
void consciousness_sleeping(t_consciousness *x, t_symbol *s, long argc, t_atom *argv);
void consciousness_waking(t_consciousness *x, t_symbol *s, long argc, t_atom *argv);
void csleep(t_object *eachob, void *dummy);
void cawake(t_object *eachob, void *dummy);

static t_class *consciousness_class = NULL;
static t_linklist *oblist;

@interface ConsciousnessReceiver : NSObject
-(void)sleepNotification: (NSNotification *)n;
-(void)wakeNotification: (NSNotification *)n;
@end

@implementation ConsciousnessReceiver

-(id)init
{
    if (self = [super init]) {
        [[[NSWorkspace sharedWorkspace] notificationCenter] addObserver: self 
                                                            selector: @selector(sleepNotification:) 
                                                            name: NSWorkspaceWillSleepNotification
                                                            object: NULL];
	
        [[[NSWorkspace sharedWorkspace] notificationCenter] addObserver: self 
                                                            selector: @selector(wakeNotification:) 
                                                            name: NSWorkspaceDidWakeNotification
                                                            object: NULL];
	}
    return (self);
}
	
-(void)sleepNotification: (NSNotification *)n
{
    linklist_funall(oblist, (method)csleep, NULL);
}
	
-(void)wakeNotification: (NSNotification *)n
{
    linklist_funall(oblist, (method)cawake, NULL);
}

-(void)dealloc
{
    [[[NSWorkspace sharedWorkspace] notificationCenter] removeObserver: self];
    [super dealloc];
}

@end

static ConsciousnessReceiver *cr;

int main(void)
{
    t_class *c;
    c = class_new("consciousness", (method)consciousness_new, (method)consciousness_free, sizeof(t_consciousness), 0L, 0);
    class_addmethod(c, (method)consciousness_assist, "assist", A_CANT, 0);
    class_addmethod(c, (method)consciousness_inletinfo, "inletinfo", A_CANT, 0);
    class_register(CLASS_BOX, c);
    consciousness_class = c;
	
    return 0;
}

void *consciousness_new()
{
    t_consciousness *x = (t_consciousness *)object_alloc(consciousness_class); 
    if (x) {
        x->c_outlet2 = bangout((t_object *)x);
        x->c_outlet1 = bangout((t_object *)x);
        if (!cr) {
            cr = [[ConsciousnessReceiver alloc] init]; 
            oblist = (t_linklist *)linklist_new();
        }
		if (oblist)
            linklist_append(oblist, x);
    }
    return(x);
}

void csleep(t_object *eachob, void *dummy)
{
    defer(eachob, (method)consciousness_sleeping, NULL, 0, NULL);
}

void cawake(t_object *eachob, void *dummy)
{
    defer(eachob, (method)consciousness_waking, NULL, 0, NULL);
}

void consciousness_sleeping(t_consciousness *x, t_symbol *s, long argc, t_atom *argv)
{ 
    outlet_bang(x->c_outlet1);
}

void consciousness_waking(t_consciousness *x, t_symbol *s, long argc, t_atom *argv)
{ 
    outlet_bang(x->c_outlet2);
}

void consciousness_assist(t_consciousness *x, void *b, long m, long index, char *s)
{
    if (m == ASSIST_INLET)
        sprintf(s,"Ignore This Inlet");
    else {
        switch (index) {	
            case 0:
                sprintf(s, "(bang) Will Sleep");
                break;
            case 1:
                sprintf(s, "(bang) Did Wake");
                break;
        }
    }
}

//inbe blue
void consciousness_inletinfo(t_consciousness *x, void *b, long index, char *t)
{
    if (index == 0)
        *t = 1;
}

void consciousness_free(t_consciousness *x)
{
    if (oblist) {
        linklist_chuckobject(oblist, x);
        if (linklist_getsize(oblist) == 0) {
            linklist_chuck(oblist);	
            if (cr) {
                [cr release];
                cr = nil;
            }
        }
    }
}
